$regfile = "m168def.dat"
$baud = 9600
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32

Const Cmaxchar = 100                                        'number of characters


Dim B As Bit                                                'a flag for signalling a received character
Dim Bc As Byte                                              'byte counter
Dim Buf As String * Cmaxchar                                'serial buffer
Dim D As Byte
Dim Sendout As Byte
Dim Devices As Integer
Dim Dat As Byte
Dim Pos As Byte
Dim S As String * 7 , Z As String * Cmaxchar
Dim Extract As String * Cmaxchar
Dim Extract1 As String * Cmaxchar
Dim Pwm As Byte
Dim Crlf As String * 8
Crlf = Chr(13) + Chr(10)
Dim Clst As String * 3
Clst = "Cls"
Dat = 15
On Urxc Rec_isr
Enable Urxc
Enable Interrupts                                           'define serial receive ISR

Config Portb.0 = Output

Dim Voltage As Word
Dim Channel As Byte
Const Ref = 5.005                                           '5.223
Dim Base As Word
Base = 1024
Dim Volt As Single
Channel = 0
'Voltage = 560
Config Portb.0 = Output
Config Portd.7 = Output
Config Portb.1 = Output
Config Portb.2 = Output
Config Adc = Single , Prescaler = Auto
Start Adc

Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Down , Prescale = 1




Do

Voltage = Getadc(channel)
Waitms 60
Volt = Voltage / Base
Volt = Volt * Ref
Print " volt" ; Volt
'Disable Serial                                      'Volt
'Serout Volt , 0 , D , 7 , 9600 , 0 , 8 , 1

If Bc > 1 Then
If Buf = "L1" Then
Set Portb.0
Disable Serial
'Serout Clst , 0 , B , 1 , 9600 , 0 , 8 , 1
Serout Buf , 0 , D , 7 , 9600 , 0 , 8 , 1
Serout Crlf , 0 , D , 7 , 9600 , 0 , 8 , 1
Pwm1a = 100
Pwm1b = 200
Bc = 0
Buf = ""
Waitms 100
Reset B                                                     'reset receive flag
Enable Serial


Elseif Buf = "L0" Then
Reset Portb.0
Disable Serial
'Serout Clst , 0 , B , 1 , 9600 , 0 , 8 , 1
Serout Buf , 0 , D , 7 , 9600 , 0 , 8 , 1
Serout Crlf , 0 , D , 7 , 9600 , 0 , 8 , 1
Pwm1a = 0
Pwm1b = 0
Bc = 0
Buf = ""
Waitms 100
Enable Serial
Else
Pos = Len(buf)
If Pos = 7 Then
Extract = Str(pos)
Extract1 = Left(buf , 4)
If Extract1 = "dimm" Then
Z = Mid(buf , 5 , 4)
Sendout = Val(z)
Pwm1a = Sendout
Waitms 100
End If
End If
Disable Serial                                          
Serout Z , 0 , D , 7 , 9600 , 0 , 8 , 1
Serout Crlf , 0 , D , 7 , 9600 , 0 , 8 , 1
'Waitms 100
Bc = 0
Buf = ""
Enable Serial
End If
End If
'End If
Loop


Rec_isr:
  D = Udr                                                   'read UDR only once
  'Print "*"                                                 ' show that we got here
  If Bc < Cmaxchar Then                                     'does it fit into the buffer?
     Incr Bc                                                'increase buffer counter
     Incr Devices
     If D = 13 Then                                         'return?
        Buf = Buf + Chr(0)
        Bc = Cmaxchar                                       'at the end
     Else
        Buf = Buf + Chr(d)                                  'add to buffer
     End If
                                                'set flag
  End If
  B = 1                                                     'set flag
Return
